class Collectable extends GenericObject
{
   var collectedSound;
   var awardValue;
   var linkageID;
   var collisionGroup = BB.COLLECTABLE;
   var collisionEnabled = true;
   var collected = false;
   var useMinScale = true;
   var generatorDisplacement = -25;
   function Collectable()
   {
      super();
      if(this.collectedSound != null)
      {
         this.setObjectSound(this.collectedSound,_root);
      }
   }
   function setCollected(collector)
   {
      this.playObjectSound();
      this.awardValue(collector);
      this.collisionEnabled = false;
      this.collected = true;
      this.renderable = false;
      this.removeFromScene();
   }
   function onAddToScene()
   {
   }
   function toString()
   {
      return "Collectable " + this.linkageID;
   }
}
