class CourseBezier extends Splines3d.Bezier
{
   var p0;
   var cp0;
   var cp1;
   var p1;
   var objects;
   var xScale = 1;
   var yScale = 1;
   function CourseBezier(p0, cp0, cp1, p1)
   {
      super();
      this.p0 = p0;
      this.cp0 = cp0;
      this.cp1 = cp1;
      this.p1 = p1;
      this.objects = [];
      this.update();
   }
   function addObject(obj, index, angle, elevation, bRotate)
   {
      this.objects.push({object:obj,angle:angle,elevation:elevation,index:index % 1,useRotation:(bRotate == null ? true : bRotate)});
   }
   function addCluster(cn, args, rotate)
   {
      var _loc5_ = arguments.splice(3);
      var _loc3_ = 0;
      while(_loc3_ < _loc5_.length)
      {
         var _loc4_ = {};
         _loc4_.__proto__ = cn.prototype;
         cn.apply(_loc4_,args);
         this.addObject(_loc4_,_loc5_[_loc3_],_loc5_[_loc3_ + 1],_loc5_[_loc3_ + 2],rotate);
         _loc3_ += 3;
      }
   }
}
