class GameCheckPoint extends GameNode
{
   var sound;
   var target;
   var linkageID = "BirdLine";
   var value = 0;
   function GameCheckPoint(value)
   {
      super();
      this.value = value;
   }
   function onAddToWorld()
   {
      this.sound = this.attachSound("Checkpoint",_root);
   }
   function onAddToScene()
   {
      this.target.gotoAndStop("checkpoint");
      this.radius = 10000;
   }
   function onCross(obj)
   {
      if(obj.keepTrackOfTime)
      {
         obj.timeRemaining += this.value;
         this.sound.start();
      }
   }
}
