class GameLetter extends Collectable
{
   var letterNumber;
   var target;
   var collectedSound = "GameLetterSound";
   var linkageID = "GameLetters";
   var value = 1000;
   var collisionGroup = BB.LETTER;
   var useRotation = false;
   function GameLetter(letterNumber)
   {
      super();
      this.letterNumber = letterNumber;
   }
   function onAddToScene()
   {
      this.target.gotoAndStop(this.letterNumber + 1);
   }
   function awardValue(obj)
   {
      obj.collectLetter(this.value,this.letterNumber);
   }
   function toString()
   {
      return "Letter";
   }
}
