class GamePoint extends Collectable
{
   var linkageID;
   var value;
   static var LOW_VALUE = 0;
   static var MEDIUM_VALUE = 1;
   static var HIGH_VALUE = 2;
   var collisionGroup = BB.POINTS;
   var collectedSound = "Point Small";
   function GamePoint(type)
   {
      super();
      switch(type)
      {
         case GamePoint.LOW_VALUE:
         default:
            this.linkageID = "PointLowValue";
            this.value = 250;
            this.collectedSound = "Point Small";
            break;
         case GamePoint.HIGH_VALUE:
            this.linkageID = "PointHighValue";
            this.value = 1000;
            this.collectedSound = "Point Large";
            this.setObjectSound("Point Large",_root);
      }
   }
   function awardValue(obj)
   {
      obj.addPoints(this.value);
   }
}
